Move independent repo myunison into this repo
[distro-setup] / mount-latest-subvol
1 #!/bin/bash
2 # Copyright (C) 2016 Ian Kelling
3 #
4 # Licensed under the Apache License, Version 2.0 (the "License");
5 # you may not use this file except in compliance with the License.
6 # You may obtain a copy of the License at
7 #
8 # http://www.apache.org/licenses/LICENSE-2.0
9 #
10 # Unless required by applicable law or agreed to in writing, software
11 # distributed under the License is distributed on an "AS IS" BASIS,
12 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 # See the License for the specific language governing permissions and
14 # limitations under the License.
15
16 # usage: mount-latest-subvol
17
18 [[ $EUID == 0 ]] || exec sudo -E "$BASH_SOURCE" "$@"
19
20 errcatch() {
21 set -E; shopt -s extdebug
22 _err-trap() {
23 err=$?
24 exec >&2
25 set +x
26 echo "${BASH_SOURCE[1]}:${BASH_LINENO[0]}:in \`$BASH_COMMAND' returned $err"
27 bash-trace 2
28 echo "$0: exiting with code $err"
29 exit $err
30 }
31 trap _err-trap ERR
32 set -o pipefail
33 }
34 bash-trace() {
35 local -i argc_index=0 arg frame i start=${1:-1} max_indent=8 indent
36 local source
37 local extdebug=false
38 if [[ $(shopt -p extdebug) == *-s* ]]; then
39 extdebug=true
40 fi
41
42 for ((frame=0; frame < ${#FUNCNAME[@]}-1; frame++)); do
43 argc=${BASH_ARGC[frame]}
44 argc_index+=$argc
45 ((frame < start)) && continue
46 if (( ${#BASH_SOURCE[@]} > 1 )); then
47 source="${BASH_SOURCE[frame+1]}:${BASH_LINENO[frame]}:"
48 fi
49 indent=$((frame-start+1))
50 indent=$((indent < max_indent ? indent : max_indent))
51 printf "%${indent}s↳%sin \`%s" '' "$source" "${FUNCNAME[frame]}"
52 if $extdebug; then
53 for ((i=argc_index-1; i >= argc_index-argc; i--)); do
54 printf " %s" "${BASH_ARGV[i]}"
55 done
56 fi
57 echo \'
58 done
59 }
60 errcatch
61
62 tu() {
63 while read -r line; do
64 file="$1"
65 grep -xFq "$line" "$file" || tee -a "$file"<<<"$line"
66 done
67 }
68 e() { printf "%s\n" "$*"; "$@"; }
69 mnt() {
70 dir=$1
71 if ! mountpoint $dir &>/dev/null; then
72 mkdir -p $dir
73 e mount $dir
74 fi
75 }
76
77 ret=0
78
79 ##### begin setup fstab for subvols we care about ######
80 first_root_crypt=$(awk '$2 == "/" {print $1}' /etc/mtab)
81 tu /etc/fstab <<EOF
82 $first_root_crypt /a btrfs noatime,subvol=a 0 0
83 EOF
84 case $HOSTNAME in
85 treetowl|x2|frodo)
86 tu /etc/fstab <<EOF
87 $first_root_crypt /q btrfs noatime,subvol=q 0 0
88 $first_root_crypt /o btrfs noatime,subvol=o 0 0
89 /q/p /p none bind 0 0
90 /o/m /m none bind 0 0
91 EOF
92 ;;
93 esac
94 ##### end setup fstab for subvols we care about ######
95
96 for vol in q a o; do
97 d=/$vol
98 if ! awk '{print $2}' /etc/fstab | grep -xF $d &>/dev/null; then
99 continue
100 fi
101
102
103 ##### begin building up list of bind mounts ######
104 binds=() # list of bind mounts
105 roots=($d) # list of bind mounts, plus the original mount
106 while true; do
107 new_roots=()
108 for r in ${roots[@]}; do
109 # eg. when r=/q/p, for lines like
110 # /q/p /p none bind 0 0
111 # output /p
112 new_roots+=($(sed -rn "s#^$r/\S+\s+(\S+)\s+none\s+bind\s.*#\1#p" /etc/fstab))
113 done
114 (( ${#new_roots} )) || break
115 binds+=(${new_roots[@]})
116 roots=( ${new_roots[@]} )
117 done
118 ##### end building up list of bind mounts ######
119
120
121 # if latest is already mounted, make sure binds are mounted and move on
122 if e check-subvol-stale $d; then
123 for b in ${binds[@]}; do
124 mnt $b
125 done
126 continue
127 fi
128
129 last_snap=$(</nocow/btrfs-stale/$vol)
130 if [[ ! $last_snap ]]; then
131 echo "$0: error. empty last_snap var"
132 ret=1
133 continue
134 fi
135
136 umount_ret=true
137 unmounted=()
138 for dir in $(echo $d ${binds[*]}\ |tac -s\ ); do
139 if mountpoint $dir; then
140 if e umount -R $dir; then
141 unmounted+=($dir)
142 else
143 umount_ret=false
144 ret=1
145 echo "$0: failed to umount $dir"
146 break
147 fi
148 fi
149 done
150
151 if ! $umount_ret; then
152 for dir in ${unmounted[@]}; do
153 mnt $dir
154 done
155 continue
156 fi
157
158 cd /mnt/root
159 if [[ -e $vol ]]; then
160 e btrfs sub del $vol
161 fi
162 # Note, we make a few assumptions in this script, like
163 # $d was not a different subvol id than $vol, and
164 # things otherwise didn't get mounted very strangely.
165 e btrfs sub snapshot btrbk/$last_snap $vol
166 for dir in $d ${binds[@]}; do
167 e mnt $dir
168 done
169 stale_dir=/nocow/btrfs-stale
170 rm -f $stale_dir/$d
171 done
172
173 if [[ $HOSTNAME == treetowl ]]; then
174 # partitioned it with fai partitioner outside of fai,
175 # because it\'s worth it to have 1% space reserved for boot and
176 # swap partitions in case I ever want to boot off those drives.
177 # as root:
178 # . /a/bin/fai/fai-wrapper
179 # eval-fai-classfile /a/bin/fai/fai/config/class/51-multi-boot
180 # fai-setclass ROTATIONAL
181 # export LUKS_DIR=/q/root/luks/
182 # # because the partition nums existed already
183 # fai-setclass REPARTITION
184 # /a/bin/fai/fai/config/hooks/partition.DEFAULT
185
186 devs=(
187 ata-TOSHIBA_MD04ACA500_84REK6NTFS9A-part1
188 ata-TOSHIBA_MD04ACA500_84R2K773FS9A-part1
189 ata-TOSHIBA_MD04ACA500_8471K430FS9A-part1
190 ata-TOSHIBA_MD04ACA500_8481K493FS9A-part1
191 )
192 first=true
193 for dev in ${devs[@]}; do
194 if $first; then
195 first=false
196 tu /etc/fstab <<EOF
197 /dev/mapper/crypt_dev_$dev /i btrfs noatime,subvol=i,noauto 0 0
198 /dev/mapper/crypt_dev_$dev /mnt/iroot btrfs noatime,subvolid=0,noauto 0 0
199 EOF
200 fi
201 tu /etc/crypttab <<EOF
202 crypt_dev_$dev /dev/disk/by-id/$dev /q/root/luks/host-treetowl discard,luks
203 EOF
204 if [[ ! -e /dev/mapper/crypt_dev_$dev ]]; then
205 cryptdisks_start crypt_dev_$dev
206 fi
207 done
208 # note, could do an else here and have some kind of mount for /i
209 # on other hosts.
210 fi
211
212 exit $ret